﻿
// bmp2grpDlg.cpp : 実装ファイル
//

#include "pch.h"
#include "framework.h"
#include "bmp2grp.h"
#include "bmp2grpDlg.h"
#include "afxdialogex.h"
#include "resource.h"

#include "cfbmp.h"
extern "C" {
#include "RL.H"
}

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// アプリケーションのバージョン情報に使われる CAboutDlg ダイアログ

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// ダイアログ データ
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV サポート

// 実装
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// Cbmp2grpDlg ダイアログ



Cbmp2grpDlg::Cbmp2grpDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_BMP2GRP_DIALOG, pParent)
	, m_strBmpFilename(_T(""))
	, m_strOutDir(_T(""))
	, m_baseName(_T(""))
	, m_check16B(FALSE)
	, m_check256B(FALSE)
	, m_check16RL(FALSE)
	, m_check256RL(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void Cbmp2grpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_BMP_FILENAME, m_strBmpFilename);
	DDX_Text(pDX, IDC_EDIT_OUTDIR, m_strOutDir);
	DDX_Text(pDX, IDC_EDIT_BASENAME, m_baseName);
	DDX_Check(pDX, IDC_CHECK_16B, m_check16B);
	DDX_Check(pDX, IDC_CHECK_256B, m_check256B);
	DDX_Check(pDX, IDC_CHECK_16RL, m_check16RL);
	DDX_Check(pDX, IDC_CHECK_256RL, m_check256RL);
}

BEGIN_MESSAGE_MAP(Cbmp2grpDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_REF_OUTDIR, &Cbmp2grpDlg::OnBnClickedButtonRefOutdir)
	ON_BN_CLICKED(IDC_BUTTON_REF_BMP, &Cbmp2grpDlg::OnBnClickedButtonRefBmp)
	ON_BN_CLICKED(IDC_BUTTON_CONVERT, &Cbmp2grpDlg::OnBnClickedButtonConvert)
END_MESSAGE_MAP()


// Cbmp2grpDlg メッセージ ハンドラー

BOOL Cbmp2grpDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "バージョン情報..." メニューをシステム メニューに追加します。

	// IDM_ABOUTBOX は、システム コマンドの範囲内になければなりません。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	// TODO: 初期化をここに追加します。

	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}

void Cbmp2grpDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void Cbmp2grpDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
		RedrawScreen();
	}
}

// ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR Cbmp2grpDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


/// <summary>
/// 出力先フォルダを選ぶ
/// </summary>
void Cbmp2grpDlg::OnBnClickedButtonRefOutdir()
{
	UpdateData();
	CFolderPickerDialog folderDialog(m_strOutDir);

	// ダイアログ表示
	if (folderDialog.DoModal() == IDOK)
	{
		CString fullPathName = folderDialog.GetPathName();
		m_strOutDir = fullPathName;
		UpdateData(FALSE);
	}
}


void Cbmp2grpDlg::OnBnClickedButtonRefBmp()
{
	UpdateData();
	CFileDialog fileDialog(true, m_strBmpFilename);

	// ダイアログ表示
	if (fileDialog.DoModal() != IDOK) {
		return;
	}

	// フルパス取得
	CString fullPathName = fileDialog.GetPathName();
	m_strBmpFilename = fullPathName;
	UpdateData(FALSE);

	// 画像準備
	CDC* pDC = GetDC();
	BOOL bRes = m_edgeBmp.Load(m_strBmpFilename, pDC);
	if (bRes == FALSE) {
		MessageBox(L"BMPファイルの読み込みでエラーが発生しました。");
		m_edgeBmp.Free();
		return;
	}

	// 色数が違ったらエラー
	int depth = m_edgeBmp.GetColorDepth();
	if (depth != 8) {
		MessageBox(L"256色のBMPを指定してください。");
		m_edgeBmp.Free();
		return;
	}
	if ((m_edgeBmp.GetWidth() != 512) && (m_edgeBmp.GetWidth() != 1024)) {
		MessageBox(L"幅が512pixelもしくは1024pixelのBMPを指定してください。");
		m_edgeBmp.Free();
		return;
	}
	ReleaseDC(pDC);

	// 画像再表示
	this->RedrawScreen();
}

/// <summary>
/// 変換実行
/// </summary>
void Cbmp2grpDlg::OnBnClickedButtonConvert()
{
	// データ取り込み
	UpdateData();

	// 保存処理
	BOOL bRes = FALSE;
	if (m_check16B) {
		bRes = save16Beta();
	}
	if (m_check256B) {
		bRes = save256Beta();
	}
	if (m_check16RL) {
		bRes = save16RL();
	}
	if (m_check256RL) {
		bRes = save256RL();
	}

	// 終了処理
	if (!bRes) {
		MessageBox(L"保存処理中にエラーが発生しました");
		return;
	}
	MessageBox(L"変換処理完了");
}

BOOL Cbmp2grpDlg::save16Beta() {
	FILE* fn;
	CDC* pDC = GetDC();
	Cfbmp bmp;

	// ビットマップ画像を読み込む
	bmp.Load(m_strBmpFilename, pDC);
	int colorDepth = bmp.GetColorDepth();

	// 色数不正
	if (colorDepth != 8) {
		MessageBox(L"256色のBMPファイルを指定してください。");
		return FALSE;
	}

	// GRPデータを出力する
	CString grpFilename = CString(m_strOutDir) + "\\" + m_baseName + ".GRP";
	fn = _wfopen(grpFilename.GetString(), L"wb");
	if (fn == NULL) {
		MessageBox(L"GRPファイルのファイルを新規作成できませんでした。");
		return FALSE;
	}
	for (int y = 0; y < bmp.GetHeight(); y++) {
		for (int x = 0; x < bmp.GetWidth(); x++) {
			WORD value = (BYTE)(bmp.GetPixelIndex(x, y));
			BYTE l = (BYTE)((value >> 8) & 0x00FF);
			BYTE r = (BYTE)((value) & 0x00FF);
			fputc(l, fn);
			fputc(r, fn);
		}
	}
	fclose(fn);

	// 16色パレットを出力する
	CString pal16Filename = CString(m_strOutDir) + "\\" + m_baseName + "_16.PAL";
	fn = _wfopen(pal16Filename, L"wb");
	if (fn == NULL) {
		MessageBox(L"16色パレットのファイルを新規作成できませんでした。");
		return FALSE;
	}
	for (int i = 0; i < 16; i++) {
		RGBQUAD quad = bmp.GetPalet(i);
		int red = quad.rgbRed;
		int green = quad.rgbGreen;
		int blue = quad.rgbBlue;

		red = (red * 31) / 255;
		green = (green * 31) / 255;
		blue = (blue * 31) / 255;

		WORD value = 0;
		value += (green & 0b0000000000011111) << 11;
		value += (red & 0b0000000000011111) << 6;
		value += (blue & 0b0000000000011111) << 1;

		fputc((value >> 8) & 0xFF, fn);
		fputc(value & 0xFF, fn);
	}
	fclose(fn);

	// リソース解放
	bmp.Free();
	ReleaseDC(pDC);

	return TRUE;
}

BOOL Cbmp2grpDlg::save256Beta() {
	FILE* fn;
	CDC* pDC = GetDC();
	Cfbmp bmp;

	// ビットマップ画像を読み込む
	bmp.Load(m_strBmpFilename, pDC);
	int colorDepth = bmp.GetColorDepth();

	// 色数不正
	if (colorDepth != 8) {
		MessageBox(L"256色のBMPファイルを指定してください。");
		return FALSE;
	}

	// GRPデータを出力する
	CString grpFilename = CString(m_strOutDir) + "\\" + m_baseName + ".GRP";
	fn = _wfopen(grpFilename.GetString(), L"wb");
	if (fn == NULL) {
		MessageBox(L"GRPファイルのファイルを新規作成できませんでした。");
		return FALSE;
	}
	for (int y = 0; y < bmp.GetHeight(); y++) {
		for (int x = 0; x < bmp.GetWidth(); x++) {
			WORD value = (BYTE)(bmp.GetPixelIndex(x, y));
			BYTE l = (BYTE)((value >> 8) & 0x00FF);
			BYTE r = (BYTE)((value) & 0x00FF);
			fputc(l, fn);
			fputc(r, fn);
		}
	}
	fclose(fn);

	// 256パレットを出力する
	CString pal256Filename = CString(m_strOutDir) + "\\" + m_baseName + "_256.PAL";
	fn = _wfopen(pal256Filename, L"wb");
	if (fn == NULL) {
		MessageBox(L"256色パレットのファイルを新規作成できませんでした。");
		return FALSE;
	}
	for (int i = 0; i < 256; i++) {
		RGBQUAD quad = bmp.GetPalet(i);
		int red = quad.rgbRed;
		int green = quad.rgbGreen;
		int blue = quad.rgbBlue;

		red = (red * 31) / 255;
		green = (green * 31) / 255;
		blue = (blue * 31) / 255;

		WORD value = 0;
		value += (green & 0b0000000000011111) << 11;
		value += (red & 0b0000000000011111) << 6;
		value += (blue & 0b0000000000011111) << 1;

		fputc((value >> 8) & 0xFF, fn);
		fputc(value & 0xFF, fn);
	}
	fclose(fn);

	// リソースを解放
	bmp.Free();
	ReleaseDC(pDC);

	// 終了
	return TRUE;
}

BOOL Cbmp2grpDlg::save16RL() {
	FILE* fn;
	CDC* pDC = GetDC();
	Cfbmp bmp;

	// ビットマップ画像を読み込む
	bmp.Load(m_strBmpFilename, pDC);
	int colorDepth = bmp.GetColorDepth();

	// 色数不正
	if (colorDepth != 8) {
		MessageBox(L"256色のBMPファイルを指定してください。");
		return FALSE;
	}

	// GRPをRLに変換
	int pixelCount = bmp.GetWidth() * bmp.GetHeight();
	BYTE* source = (BYTE*)(malloc(pixelCount));
	BYTE* dest = (BYTE*)(malloc(pixelCount * 2));
	BYTE* p = NULL;
	int outSize = 0;
	CString rlFilename;

	// 16色sourceを用意
	memset(source, 0, pixelCount);
	memset(dest, 0, pixelCount * 2);
	p = source;
	for (int y = 0; y < bmp.GetHeight(); y++) {
		for (int x = 0; x < bmp.GetWidth(); x += 2) {
			BYTE l = bmp.GetPixelIndex(x, y);
			BYTE r = bmp.GetPixelIndex(x + 1, y);
			BYTE value = ((l << 4) + r) & 0xFF;
			*p++ = value;
		}
	}

	// 変換
	outSize = rl_arc_b((char*)source, (char*)dest, pixelCount / 2);

	// 書き込み
	rlFilename = CString(m_strOutDir) + CString("\\") + CString(m_baseName) + CString("_16.RL");
	fn = _wfopen(rlFilename, L"wb");
	for (int i = 0; i < 16; i++) {
		RGBQUAD quad = bmp.GetPalet(i);
		int red = quad.rgbRed;
		int green = quad.rgbGreen;
		int blue = quad.rgbBlue;

		red = (red * 31) / 255;
		green = (green * 31) / 255;
		blue = (blue * 31) / 255;

		WORD value = 0;
		value += (green & 0b0000000000011111) << 11;
		value += (red & 0b0000000000011111) << 6;
		value += (blue & 0b0000000000011111) << 1;

		fputc((value >> 8) & 0xFF, fn);
		fputc(value & 0xFF, fn);
	}
	fwrite((const void*)dest, outSize, 1, fn);
	fclose(fn);

	// メモリ解放
	free(dest);
	free(source);

	// リソース解放
	bmp.Free();
	ReleaseDC(pDC);

	return TRUE;
}

BOOL Cbmp2grpDlg::save256RL() {
	FILE* fn;
	CDC* pDC = GetDC();
	Cfbmp bmp;

	// ビットマップ画像を読み込む
	bmp.Load(m_strBmpFilename, pDC);
	int colorDepth = bmp.GetColorDepth();

	// 色数不正
	if (colorDepth != 8) {
		MessageBox(L"256色のBMPファイルを指定してください。");
		return FALSE;
	}

	// GRPをRLに変換
	int pixelCount = bmp.GetWidth() * bmp.GetHeight();
	BYTE* source = (BYTE*)(malloc(pixelCount));
	BYTE* dest = (BYTE*)(malloc(pixelCount * 2));
	BYTE* p = NULL;
	int outSize = 0;
	CString rlFilename;

	// 256色sourceを用意
	memset(source, 0, pixelCount);
	memset(dest, 0, pixelCount * 2);
	p = source;
	for (int y = 0; y < bmp.GetHeight(); y++) {
		for (int x = 0; x < bmp.GetWidth(); x++) {
			*p++ = bmp.GetPixelIndex(x, y);
		}
	}

	// 変換
	outSize = rl_arc_b((char*)source, (char*)dest, pixelCount);

	// 書き込み
	rlFilename = CString(m_strOutDir) + CString("\\") + CString(m_baseName) + CString("_256.RL");
	fn = _wfopen(rlFilename, L"wb");
	for (int i = 0; i < 256; i++) {
		RGBQUAD quad = bmp.GetPalet(i);
		int red = quad.rgbRed;
		int green = quad.rgbGreen;
		int blue = quad.rgbBlue;

		red = (red * 31) / 255;
		green = (green * 31) / 255;
		blue = (blue * 31) / 255;

		WORD value = 0;
		value += (green & 0b0000000000011111) << 11;
		value += (red & 0b0000000000011111) << 6;
		value += (blue & 0b0000000000011111) << 1;

		fputc((value >> 8) & 0xFF, fn);
		fputc(value & 0xFF, fn);
	}
	fwrite((const void*)dest, outSize, 1, fn);
	fclose(fn);

	// メモリ解放
	free(dest);
	free(source);

	bmp.Free();
	ReleaseDC(pDC);

	return TRUE;
}


/// <summary>
/// 
/// </summary>
void Cbmp2grpDlg::RedrawScreen() {
	// 準備できていなければ無視
	if (!m_edgeBmp.isReady()) {
		return;
	}

	// 表示
	CDC* pDC = GetDC();

	// 全体の倍率を得る
	double zw1 = ((double)512) / ((double)m_edgeBmp.GetWidth());
	double zw2 = ((double)512) / ((double)m_edgeBmp.GetHeight());
	double zw = min(zw1, zw2);

	// Xの縮小率を求める
	int width = (int)(m_edgeBmp.GetWidth() * zw);
	int height = (int)(m_edgeBmp.GetHeight() * zw);

	int x = 28;
	int y = 130;
	m_edgeBmp.StretchDraw(CRect(0, 0, m_edgeBmp.GetWidth(), m_edgeBmp.GetHeight()), CRect(x, y, x + width, y + height), pDC);

	// 解放
	ReleaseDC(pDC);
}

